#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in the this distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################



##################################################################
###  ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------###
##################################################################


### Pull In External Files ###

    require ("iweb.pm");
    require ("hsadmin.pm");

    &parse_form;
    &Validate_Admin;


### Define Images and Data Files ###


$PROGRAM="Hyperseek Search Engine (Admin Search)";
$VERSION="4.02";

    $Index_File = "$data_dir/hyperseek.dat";
    $summary_file = "$data_dir/summaries.html";
    $sub_category_data = "$data_dir/subcategories.dat";
    $category_main = "$data_dir/categories.dat";
    $BigFolder = "$button_dir/big_folder.gif";
    $SmallFolder = "$button_dir/folder.gif";
    $RelatedFolder = "$button_dir/related.gif";
    $COOL = "<A HREF=\"$CGI_DIR/cool.cgi\"><IMG SRC=\"$button_dir/cool.gif\" BORDER=0></A>";
    $NEW = "<A HREF=\"$CGI_DIR/new.cgi\"><IMG SRC=\"$button_dir/new.gif\" BORDER=0></A>";



### Words to ignore ###

    $Ignore .= " what how who which when where do you find site get and ";
    $Ignore .= " or if not a the for an it of from by the one two to he ";
    $Ignore .= " most all about i me search is are be been with why ";



### The "Nothing Found Message ### 

    $No_Documents_Found = <<EOM;
    <BLOCKQUOTE>
    <I>Unfortunately, we didn't find any documents which matched your 
    search terms. You may want to visit our <A HREF="$Search_Page">search 
    tips</A> page to better refine your queries.<BR>
    <BR>If all else fails, write to us at <A HREF="$email">
    $email</A> and we'll assist in your search.</I>
    </BLOCKQUOTE>
EOM


### Get the input from the Browser ###


   if ($ENV{'QUERY_STRING'} =~ /^Range=([^\&]*)\&Format=([^\&]*)\&Terms=([^\&]*)\&Rank=(.*)/i)
   {
      ($Range,$Format,$terms,$rank) = ($1,$2,$3,$4);
      $Encoded_Terms = $terms;
      $terms =~ tr/+/ /;
      $terms =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
      $Saved_Terms = $terms;
   }
   elsif ($ENV{'QUERY_STRING'} =~ /^Range=([^\&]*)\&Format=([^\&]*)\&Terms=([^\&]*)/i)
   {
      ($Range,$Format,$terms,$rank) = ($1,$2,$3,1);
      $Encoded_Terms = $terms;
      $terms =~ tr/+/ /;
      $terms =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
      $Saved_Terms = $terms;
   }
   else
   {
      print "Location: $Search_Page\n\n";
      exit;
   }

   $terms = " " . $terms . " ";
   $terms =~ s/\s+/ /g;

   ## Split out the mailto and url requests...
   $check_special = $terms;
   $DEL="http://";
   $check_special =~ s/$DEL//g; 
 
   @CHECK = split(/\:/,$check_special);
      if ($#CHECK > 0) { 
         $Prefix = $CHECK[0];
         $Search_By = lc($Prefix);
         $Search_By =~ s/ //g;
         $terms = $CHECK[1];
         $terms =~ s/ //g;
      }

   @Raw_Terms = split(/\"/,$terms);
   $terms = "";




##############################################
#  Begin the search                          #
##############################################

   print "Content-Type: text/html\n\n";
   &Admin_Header("search");
   &Go_Search;



sub Go_Search {


   foreach $term (@Raw_Terms)

	{
	if ($i == 1)
		{$i--;}
	else
		{$i++;}
	$term =~ s/ /_/g unless $i;
	$terms .= $term;
	}

   $terms =~ s/ not / -/ig;
   $terms =~ s/ and / \+/ig;
   $terms =~ s/ or / \|/ig;


   $WildCard = "thewildcardisaveryspecialcharacter";
   $terms =~ s/(\*+)/$WildCard/g;
   @terms = split(/\s+/,$terms);


   foreach $term (@terms)


	{
	next if ($term eq "");
	if (($Ignore =~ / $term /i) && ($term !~ /^\W/))
		{
		$Ignored_Terms .= $term . ", ";
		next;
		}
	if ($term =~ /$WildCard/)
		{
		$Beta = $term;
		$Beta =~ s/$WildCard//g;
		$Beta =~ s/\W//g;
		$Beta =~ s/_//g;
		if (length($Beta) < 3)
			{
			$Ignored_Terms .= $term . ", ";
			next;
			}
		}
	$term =~ s/_/ /g;
	if ($term =~ /^-/)
		{
		if ($term =~ / /)
			{
			$Ignored_Terms .= "\"" . $term . "\", ";
			}
		else
			{
			$Ignored_Terms .= $term . ", ";
			}
		push(@forbidden,&Format_Term($term));
		}
	elsif (($term =~ /^\|/) || (($Range eq "Any") && ($term !~ /^\+/)))
		{
		if ($term =~ / /)
			{
			$Important_Terms .= "\"" . $term . "\", ";
			}
		else
			{
			$Important_Terms .= $term . ", ";
			}
		push(@optional,&Format_Term($term));
		}
	else
		{
		if ($term =~ / /)
			{
			$Important_Terms .= "\"" . $term . "\", ";
			}
		else
			{
			$Important_Terms .= $term . ", ";
			}
		push(@required,&Format_Term($term));
		}
	}



   $delimiter = '|';
   open(ALLFILE,"$Index_File") || &Fatal;
   foreach $LINE (<ALLFILE>)
	{
	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

        if ($Search_By eq "url") { 
            $string = $URL; 
            $string =~ s/http\:\/\///g;
        }
        elsif ($Search_By eq "mailto") { 
               $string = $Email; 
        }
        else { $string = "$Description $Keys"; }

	$string =~ s/\n/ /g;
	($Relevance,$Kill) = (0,0);
	foreach (@forbidden)
		{
		if (($string =~ /$_/i) && ($_ !~ /[A-Z]/))
			{
			$Kill++;
			last;
			}
		elsif ($string =~ /$_/)
			{
			$Kill++;
			last;
			}
		}
	next if ($Kill);
	foreach (@required)
		{
		if (($string =~ /$_/) && ($_ =~ /[A-Z]/))
			{
			$Relevance += (($string =~ s/$_/$_/og) + 20);
			}
		elsif (($string =~ /$_/i) && ($_ !~ /[A-Z]/))
			{
			$Relevance += (($string =~ s/$_/$_/oig) + 10);
			}
		else
			{
			$Kill++;
			last;
			}
		}
	next if ($Kill);
	foreach (@optional)
		{
		if (($string =~ /$_/) && ($_ =~ /[A-Z]/))
			{
			$Relevance += ($string =~ s/$_/$_/og);
			}
		elsif (($string =~ /$_/i) && ($_ !~ /[A-Z]/))
			{
			$Relevance += ($string =~ s/$_/$_/oig);
			}
		}
	&Include if ($Relevance && $URL ne "NONE" && $URL ne "None" && $URL ne "none");
	}
   close(ALLFILE);


   if ($Ignored_Terms =~ /(.*)\, /)
	{
	$Ignored_Terms = " " . $1;
	$Ignored_Terms =~ s/$WildCard/\*/g;
	$Ignored_Terms =~ s/ (\"?)\-/ $1/g;
	$summary .= "Ignored: <TT>$Ignored_Terms</TT>.<BR>\n";
	}
   else
	{
	$summary .= "<BR>\n";
	}
   if ($Important_Terms =~ /(.*)\, /)
	{
	$Important_Terms = " " . $1;
	$Important_Terms =~ s/$WildCard/\*/g;
	$Important_Terms =~ s/ (\"?)\+/ $1/g;
	$Important_Terms =~ s/ (\"?)\|/ $1/g;

        if ($Search_By eq "url") { $Heading .= "Searched for the $Search_By: <B>$Important_Terms</B>.<BR>\n"; }
        elsif ($Search_By eq "mailto") { $Heading .= "Searched for entries submitted by: <B>$Important_Terms</B>.<BR>\n"; }
	else { $Heading .= "Searched for: <B>$Important_Terms</B>.<BR>\n"; }

	}
   $Remaining = ($hitcount - $rank) - ($Hits_Per_Page - 1);
   if ($Remaining > $Hits_Per_Page)
	{
	$Next = $Hits_Per_Page;
	$New_Rank = $rank + $Hits_Per_Page;
	}
   elsif ($Remaining > 0)
	{
	$Next = $Remaining % $Hits_Per_Page;
	$New_Rank = $rank + $Hits_Per_Page;
	}
   else
	{
	$New_Rank = $hitcount + 1;
	}


   $summary .= "Displaying documents " . $rank . "-" . ($New_Rank - 1);
   $summary .= " of $hitcount, ranked in order of relevance...<BR>\n";
   if (($summary_file) && (-e $summary_file))
	{
	open(SUMMARY,">>$summary_file");
	print SUMMARY "Raw Query: $Saved_Terms<BR>\n";
	close(SUMMARY);
	}



   print "<FONT COLOR=\"$text_color\" FACE=\"$font_face\">\n";
   print "<TABLE WIDTH=\"90%\"><TR BGCOLOR=\"$win_color\"><TD><B>Search Results....</B></TD></TR></TABLE></FONT>\n";
   print $Heading;


   if ($hitcount > 0)
	{
	if ($Format eq "Standard")
		{
		print "<BR>\n<BLOCKQUOTE>\n<DL>\n";
		}
	else
		{
		print "<BR>\n<PRE>\n";
		}
	$i = 0;

        print "<H4>Hyperseek Category Matches...</H4>\n";
	foreach $key (reverse sort keys %CATS) 
	{
	   ($URL,$Title,$Description,$ID,$Cool,$Cat,$Sub) = split(/\|/,$CATS{$key});
           $LINK = "$Cat|$Sub";
           $LINK =~ s/ /+/g;
           print "<A HREF=\"$CGI_DIR/acat.cgi?password=$password&Category=$LINK\">$Cat :: $Sub</A><BR>\n"; 
        }

        print "<H4>$summary</H4>\n";

	foreach $key (keys %HITS) {

	      @{$records[$count++]}{qw(URL Title Description ID Cool Cat Sub)}=split(/\|/,$HITS{$key},8);
        }

        &Sort_by_Title;

        for $j ( 0 .. $#links ) {

		$i++;
		next if ($i < $rank);
		next if ($i > ($rank + ($Hits_Per_Page - 1)));

                $URL = $links[$j]{'URL'};
                $Title = $links[$j]{'Title'};
                $Description = $links[$j]{'Description'};
                $ID = $links[$j]{'ID'};
                $Cool = $links[$j]{'Cool'};
                $Cat = $links[$j]{'Cat'};
                $Sub = $links[$j]{'Sub'};

		if ($Format eq "Standard")
			{
			if ($Size < 1500)
				{
				$Size = "$Size bytes";
				}
			else
				{
				$Size = int($Size/1000) . " K";
				}


                        #########################################
                        ## Do we show a New Icon ??            ##
                        #########################################
                        #########################################                        
                        $EXTRA = "[ <a href=\"$CGI_DIR/hs_admin.cgi?action=Edit&id=$ID&search_type=ID&password=$password\" TARGET=\"X\" onClick=\"OpenWindow()\">Edit</a> ]";
                        $EXTRA .= " ... [ <a href=\"$CGI_DIR/hs_admin.cgi?action=Delete&id=$ID&password=$password\" TARGET=\"X\" onClick=\"OpenWindow()\">Delete</a> ]";

                        #########################################                        
                        ### Show the # of hits for this URL... ##
                        #########################################                        

                        $Cat =~ s/ /+/g;
                        $Sub =~ s/ /+/g;


			      print "<P><DT><A HREF=\"$URL\" TARGET=\"new\"><STRONG>$Title</STRONG></A>&nbsp;&nbsp;&nbsp;$EXTRA</DT>";
			      print "<DD>$Description<BR>\n<TT>$URL</TT><BR><TT><A HREF=\"$CGI_DIR/acat.cgi?Category=$Cat|$Sub&password=$password\">[More like this]</A></TT>";
			      print "</DD>\n";


			}


		else
			{
			&Compact_Print;
			}
		}
	if ($Format eq "Standard")
		{
		print "</DL>\n";
		}
	else
		{
		print "</PRE>\n";
		}

	print "Documents " . $rank . "-" . ($New_Rank - 1);
	print " of $hitcount displayed.<BR>\n";
	print "</BLOCKQUOTE>\n" if ($Format eq "Standard");
	print "<CENTER>\n";
	if ($Remaining > 0)
		{
                print "<FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
		print "<A HREF=\"$ENV{'SCRIPT_NAME'}?Range=$Range\&Format=$Format\&Terms=$Encoded_Terms\&Rank=$New_Rank&password=$password\">";
		print "<H4>Next $Next Matches</H4></A>\n";
		}
	}
	else
	{
	print $No_Documents_Found;
	}


   $Saved_Terms =~ s/\"/\&#34;/g;
   print <<EOM;
   <BR></FONT>
   <CENTER>
   <FORM METHOD=GET ACTION="$ENV{'SCRIPT_NAME'}">
   <B>Match</B> 
   <SELECT NAME="Range">
EOM

   if (($Range eq "All") && ($hitcount))
	{
	print "<OPTION VALUE=\"All\" SELECTED>All Terms";
	print "<OPTION VALUE=\"Any\">Any Term";
	}
   else
	{
	print "<OPTION VALUE=\"All\">All Terms";
	print "<OPTION VALUE=\"Any\" SELECTED>Any Term";
	}

   print <<EOM;
   </SELECT>
   <B>and show results</B> 
   <SELECT NAME="Format">
EOM

   if ($Format eq "Standard")
	{
	print "<OPTION VALUE=\"Standard\" SELECTED>in Standard Form";
	print "<OPTION VALUE=\"Compact\">in Compact Form";
	}
   else
	{
	print "<OPTION VALUE=\"Standard\">in Standard Form";
	print "<OPTION VALUE=\"Compact\" SELECTED>in Compact Form";
	}

   print <<EOM;
   </SELECT><BR>
   <INPUT NAME="Terms" SIZE=45 MAXLENGTH=800 VALUE="$Saved_Terms">
   <INPUT TYPE=hidden NAME="password" VALUE="$password">
   <INPUT TYPE=submit VALUE=" New Search ">
   </FORM></CENTER>
   <BR><H5 ALIGN=CENTER>
   <A HREF="$Search_Page">Search Tips</A> - 

EOM



   &Admin_Footer("search");


   print "</BODY></HTML>\n";

}




sub Include {

   $Relevance = ($Relevance * $Crank) if ($Crank > 1);
   $Relevance = 100000 if ($Relevance > 100000);
   $Relevance = sprintf("%.5f",($Relevance/100000));

   $CATS{"$Category$SubCategory"} = $URL . $delimiter . $Title . $delimiter . $Description . $delimiter. $ID . $delimiter . $Crank . $delimiter . $Category . $delimiter . $SubCategory;

   $HITS{"$Relevance$URL"} = $URL . $delimiter . $Title . $delimiter . $Description . $delimiter. $ID . $delimiter . $Crank . $delimiter . $Category . $delimiter . $SubCategory;
   $hitcount++;
}

sub Compact_Print {

   if (length($Title) < 25)
	{
	while (length($Title) < 25)
		{
		$Title .= " ";
		}
	}
   else
	{
	@Title_Characters = split(//,$Title);
	$Title = "";
	for ($x=0; $x<25; $x++)
		{
		$Title .= $Title_Characters[$x];
		}
	}
   if (length($Description) < 36)
	{
	while (length($Description) < 36)
		{
		$Description .= " ";
		}
	}
   else
	{
	@Descript_Characters = split(//,$Description);
	$Description = "";
	for ($x=0; $x<36; $x++)
		{
		$Description .= $Descript_Characters[$x];
		}
	}
   if (length($Last_Modified) == 8)
	{
	$Last_Modified = "0" . $Last_Modified;
	}

   if ($yh_target ne "NONE") {
      print "<FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
      print "<A HREF=\"$URL\" TARGET=\"$yh_target\">$Title</A> [$Last_Modified] $Description\n";
   }
   else {
      print "<FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
      print "<A HREF=\"$URL\">$Title</A> [$Last_Modified] $Description\n";
   }
}



sub Format_Term {


   $PERIOD=".";

   $_ = shift;

   if (! $Search_By) { 
     $_ = " " . $_ . " ";
   }

   $_ =~ s/\W/ /g;
   $_ =~ s/\s+/ /g;
   $_ =~ s/$WildCard/\(\[\^\\s\+\]\{0,4\}\)/g;


   if ($Search_By) { 
       $_ =~ s/ /$PERIOD/g;
   }

   return $_;

}



sub Fatal {

   print "Content-type: text/plain\n\n";
   print "Fatal Error: Could not read from the index file.\n";
   print "Check location at $Index_File.\n\n";

   exit;
}

sub Sort_by_Title {


        @links = sort { $a->{'Title'} cmp $b->{'Title'} } @records;

}


sub ReadCategories {

  open DAT,"$sub_category_data";
    @subcategories = <DAT>;
  close(DAT);

  ### New Category Things..
    open (CNT,"$category_main");
      while ( <CNT> ) {
        $categories={};
        foreach $rec(split /\n/,join '',<CNT>){
 	  (undef,
	   @{$categories[$cat_count++]}{qw(Category SubCategory Count Description Moderator ModeratorPW)})=split(/\|/,$rec,7);
        }
      }
    close (CNT);  
  

}

