##############################################################################
# CCS CGI Toolkit (cgitoolkit.pm)                                            #
# Copyright 2000 John Cokos, The CCS Network                                 #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:             http://www.interactive-web.net               #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# This file (cgitoolkit.cgi) may be modified so long as                      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################


##############################################################################
# PROGRAM: The CGI Toolkit
# VERSION: 1.10
##############################################################################

##############################################################################
# Do not modify anything below this point...
##############################################################################

$MAX_SLEEP = 15;
$LOCK_LOCATION = "/tmp";
$PROG_NAME = $0;
$PID = $$;

# Search for the lockfile and block until it dissapears
sub lock {
        local($_) = @_[0] || $PROG_NAME;
        @FULL_PATH = split("/");
        $LOCK_NAME = pop(@FULL_PATH);
        $LOCK_PATH = "$LOCK_LOCATION/$LOCK_NAME.lck";

        while (-e "$LOCK_PATH") {
                $SLEEP_COUNT++;
                sleep 1;
                if ($SLEEP_COUNT == $MAX_SLEEP) {
                        $! = "Persistent lock file $LOCK_PATH exists.";
                        return 0;
                }
        }
        open (LOCK, "> $LOCK_PATH") || return 0;
        print LOCK $PID;
        close (LOCK);
        1;
}

# Kill the lock file
sub unlock {
        local($_) = @_[0] || $PROG_NAME;
        @FULL_PATH = split("/");
        $LOCK_NAME = pop(@FULL_PATH);
        $LOCK_PATH = "$LOCK_LOCATION/$LOCK_NAME.lck";

        return (unlink $LOCK_PATH);
}



##############################################################################
#                    ____                      _
#                   / __ \ ____ _ _____ _____ (_)____   ____ _
#                  / /_/ // __ `// ___// ___// // __ \ / __ `/
#                 / ____// /_/ // /   (__  )/ // / / // /_/ /
#                /_/     \__,_//_/   /____//_//_/ /_/ \__, /
#                                                    /____/
#
##############################################################################
sub parse_form{

  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  if (length($buffer) < 5) {
     $buffer = $ENV{QUERY_STRING};
  }
  @pairs=split(/&/,$buffer);
  foreach $pair(@pairs) {
     ($name, $value)=split(/=/,$pair);
     $encoded_value = $value;
     $value =~ tr/+/ /;
     $value =~ s/%([a-fA-F0-9][A-F0-9])/pack("C",hex($1))/eg;
     if($input{$name} eq "") {
	$input{$name} = $value;
	$ENCODED{$name} = $encoded_value;
        push (@Fields,$name);
     }
     else {
  	$input{$name} = $input{$name}." ".$value;
     }
  }

}


##############################################################################
#                    ______               __    _
#                   / ____/____   ____   / /__ (_)___   _____
#                  / /    / __ \ / __ \ / //_// // _ \ / ___/
#                 / /___ / /_/ // /_/ // ,<  / //  __/(__  )
#                 \____/ \____/ \____//_/|_|/_/ \___//____/
#
##############################################################################

   ## Sample code to set a cookie....
   ## Note: separate cookie values with a ":"
   #  $newcookie= "voted\~Yes:iscool\~No";
   #  print "Set-Cookie: COOKIENAME=$newcookie;";
   #  print " expires=", &Cookie_Date( time + 31536000 , 1 ), "; path=/\n";

   ## Sample code to get a cookie
   #  %bbscookie= &split_cookie( $ENV{ 'HTTP_COOKIE' }, 'COOKIENAME' );
   #  $bbscookie{'voted'} and $bbscookie{'cool'} are the values...

sub split_cookie
{
   # put cookie into array
   local( $incookie, $tag )= @_;
   local( %cookie );
   $tester= $incookie;
   local( @temp )= split( /; /, $incookie );
   foreach ( @temp )
   {
      ( $temp, $temp2 )= split( /=/ );
      $cookie{ $temp }= $temp2;
   }
   return &split_sub_cookie( $cookie{ $tag } );
}

sub split_sub_cookie
{
   local( $cookie )= @_;
   local( %newcookie );
   local( @temp )= split( /:/, $cookie );
   foreach ( @temp )
   {
      ( $temp, $temp2 )= split( /~/ );
      $newcookie{ $temp }= $temp2;
   }
   return %newcookie;
}

sub join_cookie
{
   local( %set )= @_;
   local( $newcookie );
   foreach $key( keys %set )
   {
      $newcookie.= "$key\~$set{ $key }:";
   }
   return $newcookie;
}

sub Cookie_Date
{
   local( $time, $format )= @_;

   local( $sec, $min, $hour, $mday, $mon, $year,
          $wday, $yday, $isdst )= localtime( $time );

   $sec = "0$sec" if ($sec < 10);
   $min = "0$min" if ($min < 10);
   $hour = "0$hour" if ($hour < 10);
   $mon = "0$mon" if ($mon < 10);
   $mday = "0$mday" if ($mday < 10);
   local( $month )= ($mon + 1);
   local( @months )= ( "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                       "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );

   local( @weekday )=( "Monday", "Tuesday", "Wednesday",
              "Thursday", "Friday", "Saturday", "Sunday" );

   if ( !defined( $format ) ){
      return "$mday $months[$mon] 19$year at $hour\:$min\:$sec";
   }
   #else
      return "$weekday[$wday], $month-$mday-$year $hour\:$min\:$sec GMT";
}


##############################################
# SUB: Send E-mail (Using regular sendmail)
#
# Takes:
# (To, Subject, From, Mail Command, Message)

sub SendMail {
	$TO=$_[0];  @TO=split('\0',$TO);
	$SUBJECT=$_[1];
	$REPLYTO=$_[2];
	$COMMAND=$_[3];
	$THEMESSAGE = $_[4];

        open (SENDMAIL, "| $COMMAND") || die ERROR("Could not open $COMMAND");
             print SENDMAIL "To: $TO\n";
             print SENDMAIL "From: $REPLYTO\n";
             print SENDMAIL "Subject: $SUBJECT\n";
             print SENDMAIL "$THEMESSAGE\n";
          close SENDMAIL;

}


sub ERROR {


   local($ERROR_MESSAGE) = @_;

	print "Content-type: text/html\n\n";

        print <<DONE;

	<HTML>
	<HEAD>
	  <TITLE>CGI Error</TITLE>
	</HEAD>
        <BODY BGCOLOR=\"white\">
        <CENTER>
        <BR><BR><BR>
        <TABLE BORDER=2 CELLSPACING=0 CELLPADDING=0 WIDTH=300>
          <TR><TD WIDTH=300> 

        <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
          <TR><TD> 
            <TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
               <TR BGCOLOR="red"><TD> 
               <FONT FACE="Arial,Helvetica" COLOR="white" SIZE=+1>Unexpected Error.
            </TD><TR></TABLE>
          </TD></TR>

          <TR><TD> 
            <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%"><TR BGCOLOR="silver"><TD> 
              $ERROR_MESSAGE
              <PRE><CENTER><FONT COLOR="red"><< $! >>

<A HREF="$ENV{'HTTP_REFERER'}">Return to Previous Screen</A></CENTER>
            </TD><TR></TABLE>

        </TD><TR></TABLE>
        </TD><TR></TABLE>
	</BODY>
	</HTML>
DONE

   exit 0;


}






##############################################################################
#                          ____   __ __
#                         / __ \ / //_/
#                        / / / // ,<
#                       / /_/ // /| | _  _  _  _
#                       \____//_/ |_|(_)(_)(_)(_)
#
##############################################################################
sub ok_box {

        local($message) = @_[0];
        local($click) = @_[1];

	print "Content-type: text/html\n\n";

        print <<DONE;

	<HTML>
	<HEAD>
	  <TITLE>Message</TITLE>
	</HEAD>
        <BODY BGCOLOR=\"white\">
        <FORM><CENTER>
        <BR><BR><BR>
        <TABLE BORDER=2 CELLSPACING=0 CELLPADDING=0 WIDTH=300>
          <TR><TD WIDTH=300> 

        <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
          <TR><TD> 
            <TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
               <TR BGCOLOR="navy"><TD> 
               <FONT FACE="Arial,Helvitica" COLOR="ivory" SIZE=+1>Message.
            </TD><TR></TABLE>
          </TD></TR>

          <TR><TD> 
            <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%"><TR BGCOLOR="silver"><TD> 
              $message
              <PRE><CENTER>

<INPUT TYPE="button" NAME="b_ok" VALUE="Return..." onClick="$click"></CENTER>
            </TD><TR></TABLE>

        </TD><TR></TABLE>
        </TD><TR></TABLE></FORM>
	</BODY>
	</HTML>
DONE

	exit 0;


}


sub Long_Date {

   local($time) = @_;

   local( $sec, $min, $hour, $mday, $mon, $year,
          $wday, $yday, $isdst )= localtime( $time );

   $sec = "0$sec" if ($sec < 10);
   $min = "0$min" if ($min < 10);
   $hour = "0$hour" if ($hour < 10);
   $mon = "0$mon" if ($mon < 10);
   $mday = "0$mday" if ($mday < 10);
   local( $month )= ($mon + 1);
   local( @months )= ( "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                       "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );

   local( @weekday )=( "Monday", "Tuesday", "Wednesday",
              "Thursday", "Friday", "Saturday", "Sunday" );


   return "$weekday[$wday -1] $months[$month] $mday, 19$year $hour\:$min";

}


sub Short_Date {

   local($time) = @_;

   local( $sec, $min, $hour, $mday, $mon, $year,
          $wday, $yday, $isdst )= localtime( $time );

   $sec = "0$sec" if ($sec < 10);
   $min = "0$min" if ($min < 10);
   $hour = "0$hour" if ($hour < 10);
   $mon = "0$mon" if ($mon < 10);
   $mday = "0$mday" if ($mday < 10);
   local( $month )= ($mon + 1);
   local( @months )= ( "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                       "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );

   local( @weekday )=( "Monday", "Tuesday", "Wednesday",
              "Thursday", "Friday", "Saturday", "Sunday" );


   return "$weekday[$wday -1] $months[$month] $mday, 19$year";

}


sub US_Date {

   local($time) = @_;

   local( $sec, $min, $hour, $mday, $mon, $year,
          $wday, $yday, $isdst )= localtime( $time );

   $sec = "0$sec" if ($sec < 10);
   $min = "0$min" if ($min < 10);
   $hour = "0$hour" if ($hour < 10);
   $mon = "0$mon" if ($mon < 10);
   $mday = "0$mday" if ($mday < 10);
   local( $month )= ($mon + 1);

   return "$month/$mday/19$year";

}

sub Not_Alpha {

  ## This returns "1 or True if the string FAILS ....
  ## Example:  if ( &Not_Alpha($some_text) ) { &ERROR_PAGE; }

  local($string_to_check) = @_[0];

  if ($string_to_check =~ tr/;<>*|`&$!#()[]{}:'"\///) { return(1); }
  else { return(0); }


}


sub Not_Valid_Email {

    ## This returns "1 or True if the address FAILS ....
    ## Example:  if ( &Not_Valid_Email($some_address) ) { &ERROR_PAGE; }
    ## Note that the basis of this function is copyright Matthew M. Wright
    ##      we merely changed the return order and the variable names.

    local($email_address_to_check) = $_[0];

    if ($email_address_to_check =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/ || 
        ($email_address_to_check !~ /^.+\@localhost$/ && 
         $email_address_to_check !~ /^.+\@\[?(\w|[-.])+\.[a-zA-Z]{2,3}|[0-9]{1,3}\]?$/)) {
        return(1);
    }

    else {
        return(0);
    }

}


sub Not_Valid_URL {

  
   ## This returns "1 or True if the address FAILS ....
   ## Example:  if ( &Not_Valid_URL($some_url) ) { &ERROR_PAGE; }

   local($url_to_check) = @_[0];

   if ($url_to_check !~ 'http://' || $url_to_check !~ /^(f|ht)tp:\/\/\w+\.\w+/) { return(1); }
   else { return(0); }

}


sub Remove_HTML_Tags {

   local($string_to_modify) = @_[0];
   
   $string_to_modify =~ s/<[^>]+>//ig;
   return($string_to_modify);


}



sub Spelling_Errors  {

   ## Paramaters: String to check, path to dictionary ( no trailing slash )
   ## This returns "1 or True if there are spelling errors...
   ## And always returns $Spelling_Error_Message Global Variable which contains
   ## informative text about the spelling errors, warnings, and status.
   ## Example:  if ( &Spelling_Errors($text_string,"./data/dictionary") ) { &ERROR("$Spelling_Error_Message"); }

   local($d) = @_[0];
   local($dictionary) = @_[1];

   $d=~tr/A-Z/a-z/;
   $d=~tr/a-z/ /cs;
   while (substr($d,0,1) eq " "){$d=substr($d,1);} #trash leading spaces
   @f=split(/ /, $d); #split entire input string into array
   @f=sort(@f);       #sort damn you

   SORTER: 
   while($w=shift(@f)) {
      $pt++;
      if ($w eq $l){next;} #lose dupes
         $l=$w; 
         if (substr($w,0,1) ne $f) {
            undef($c);
            open (FILE, "$dictionary/".substr($w,0,1))|| &ERROR("couldn't open $w\n");
            $f = substr($w,0,1);
            while (<FILE>) {
               $c=$_;
               last;
            }
         }

         if (length($w)<3){$pp++;push(@p,$w);next SORTER;} #ignore short words, but remember what they were
         if ($c=~/\b$w\b/){$pm++;push(@m,$w);next SORTER;} 
         if (substr($w,-1,1) eq "s") {
            if ($c=~/\b$w?\b/) {
                $pq++;push(@q,$w);next SORTER;
            }
      }

      $pn++;
      push(@n,$w);
   }

   foreach $n(@n) {
      $message=~s/\b$n\b/<BLINK>$n<\/BLINK>/gi;
      $spelledtopic=~s/$n/<BLINK>$n<\/BLINK>/gi;
      $rl="<BR><CENTER>$rl | $n ";
   }

   foreach $n(@q) {
      $message=~s/$n/<BLINK>$n<\/BLINK>/gi;
      $spelledtopic=~s/$n/<BLINK>$n<\/BLINK>/gi;
   }

   
   $Spelling_Error_Message = "";
   $spelling_errors = 0;

   if (scalar(@p)>0) #shortwords
      { 
        $Spelling_Error_Message = "<BR><B>We didn't check these $pp short words:<\/B> ".join(" ",@p); 
      }

   if (scalar(@n)==1) #single word not found in dictionary
      { 
         $Spelling_Error_Message .= "<BR><B>This word isn't in our dictionary:<\/B> $rl \|</CENTER><BR>"; 
         $spelling_errors = 1;
      }

   elsif (scalar(@n)>0) #sevaral words not found in dictionary
      { 
         $Spelling_Error_Message .= "<BR><B>These $pn words weren\'t in our dictionary:<\/B> $rl \|</CENTER><BR>"; 
         $spelling_errors = 1;  
      }

   else #all is good
      { 
        $Spelling_Error_Message = "<BR><B>Our Spell Check indicates that all is good,<\/B> But double check your entry anyway.<BR>"; 
      }

   if (scalar(@q)==1) 
      { 
        $Spelling_Error_Message .= "<BR><B>This word isn't in our dictionary, but is probably a plural:<\/B>".join(" ",@q); 
        $spelling_errors = 1;  
      }

   elsif (scalar(@q)>0) 
      { 
        $Spelling_Error_Message .= "<BR><B>These words weren't in our dictionary, but are probably plurals:<\/B>".join(" ",@q); 
        $spelling_errors = 1;  
      }

    return $spelling_errors;
}


sub Bad_Words_Present {

   ## Paramaters: String to check, path to badwords file
   ## This returns "1 or True if there are spelling errors...
   ## And always creates $Bad_Word_Message Global Variable which contains
   ## informative text about the spelling errors, warnings, and status.
   ## Example:  if ( &Bad_Words_Present($text_string, "./data/badwords.txt") ) { &ERROR("$Bad_Words_Message"); }

   local($d) = @_[0];
   local($bw_file) = @_[1];
   local($w);
   local($l);
   local($f);
   local($bad);
   local($bw_exist);


   $d=~tr/A-Z/a-z/;
   $d=~tr/a-z/ /cs;
   while (substr($d,0,1) eq " "){$d=substr($d,1);} #trash leading spaces
   @f=split(/ /, $d); 
   @f=sort(@f);      

   open(BAD, "$bw_file");
 
      while (<BAD>) {
         $this_bad_word = $_;
         $this_bad_word =~ s/\n//g;
         $this_bad_word =~ s/\cM//g;

         for $w( 0 .. $#f ) {
            $l=$f[$w]; 
            $l =~ s/\n//g;
            $l =~ s/\cM//g;
            if ($this_bad_word eq $l) { 
               push @bad,$l; 
               $bw_exist = 1;
            }
         }

      }

   close(BAD);


   $Bad_Words_Message .= "The following unpermitted words were found:<BR><BLOCKQUOTE>\n";
     
     @bad=sort(@bad);
     $l = "";

     for $z ( 0 .. $#bad ) { 
        
         if($bad[$z] ne $l) {
           $Bad_Words_Message .= "$bad[$z]<BR>\n"; 
         }
         $l = $bad[$z];
     }

   $Bad_Words_Message .- "</BLOCKQUOTE>\n";

   return $bw_exist;
}


sub Invalid_IP {


   ## Paramaters: Comma separated list if valid IPs (a single string...)
   ## This returns "1 or True if the test fails
   ## Example:  
   ##
   ## $my_ip_list = "128.0.0.1,localhost,my_compuer";
   ## if ( &Invalid_IP($my_ip_list) ) { &ERROR("Invalid IP"); }

    local($param) = @_[0];
    local(@referers) = split(/\,/,$param);
    local($valid) = 1;

    print "$ENV{'HTTP_REFERER'}\n";
    if ($ENV{'HTTP_REFERER'}) {
        foreach $referer (@referers) {
            if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
                $valid = 0;
                last;
            }
        }
    }
    else {
        $valid = 0;
    }

    
    return($valid);
}

1;
