#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in this distribution      #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################



##################################################################
###  ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------###
##################################################################


### Pull In External Files ###

    require ("iweb.pm");
    require ("hyperseek.pm");


### Define Images and Data Files ###


$PROGRAM="Hyperseek Search Engine (Free Text Search)";
$VERSION="6.01";

    $Index_File = "$data_dir/hyperseek.dat";
    $summary_file = "$data_dir/search.log";
    $sub_category_data = "$data_dir/subcategories.dat";
    $category_main = "$data_dir/categories.dat";
    $BigFolder = "$button_dir/big_folder.gif";
    $SmallFolder = "$button_dir/folder.gif";
    $RelatedFolder = "$button_dir/related.gif";



### Words to ignore ###

    $Ignore .= " what how who which when where do you find site get and ";
    $Ignore .= " or if not a the for an it of from by the one two to he ";
    $Ignore .= " most all about i me search is are be been with why ";



### Get the input from the Browser ###

   &parse_form;
   $terms = $input{'Terms'};
     $Encoded_Terms = $ENCODED{'Terms'};
     $Encoded_Terms =~ s/ /+/g;

   $Range = $input{'Range'};
   $Format = $input{'Format'};
   $rank = $input{'Rank'};
    if(! $rank) { $rank = 1; }
   $ReqQualifier = $input{'Qualifier'};
    if ($ReqQualifier eq "NONE") { $ReqQualifier = "" };
        $QualLink = $ReqQualifier;
        $QualLink =~ s/ /+/g;

   $Saved_Terms = $terms;

   $terms = " " . $terms . " ";
   $terms =~ s/\s+/ /g;

   ## Split out the mailto and url requests...
   $check_special = $terms;
   $DEL="http://";
   $check_special =~ s/$DEL//g; 
 
   @CHECK = split(/\:/,$check_special);
      if ($#CHECK > 0) { 
         $Prefix = $CHECK[0];
         $Search_By = lc($Prefix);
         $Search_By =~ s/ //g;
         $terms = $CHECK[1];
         $terms =~ s/ //g;
      }

   @Raw_Terms = split(/\"/,$terms);
   $terms = "";

   $BANNER_GROUP = $Raw_Terms[0];
   $BANNER_GROUP =~ s/(\*+)//g;

   &Page_Header($BANNER_GROUP,"search");
   exit 0;




sub Body {

   &Go_Search;

}


sub Go_Search {


   foreach $term (@Raw_Terms)

	{
	if ($i == 1)
		{$i--;}
	else
		{$i++;}
	$term =~ s/ /_/g unless $i;
	$terms .= $term;
	}

   $terms =~ s/ not / -/ig;
   $terms =~ s/ and / \+/ig;
   $terms =~ s/ or / \|/ig;


   $WildCard = "thewildcardisaveryspecialcharacter";
   $terms =~ s/(\*+)/$WildCard/g;
   @terms = split(/\s+/,$terms);


   foreach $term (@terms)


	{
	next if ($term eq "");
	if (($Ignore =~ / $term /i) && ($term !~ /^\W/))
		{
		$Ignored_Terms .= $term . ", ";
		next;
		}
	if ($term =~ /$WildCard/)
		{
		$Beta = $term;
		$Beta =~ s/$WildCard//g;
		$Beta =~ s/\W//g;
		$Beta =~ s/_//g;
		if (length($Beta) < 3)
			{
			$Ignored_Terms .= $term . ", ";
			next;
			}
		}
	$term =~ s/_/ /g;
	if ($term =~ /^-/)
		{
		if ($term =~ / /)
			{
			$Ignored_Terms .= "\"" . $term . "\", ";
			}
		else
			{
			$Ignored_Terms .= $term . ", ";
			}
		push(@forbidden,&Format_Term($term));
		}
	elsif (($term =~ /^\|/) || (($Range eq "Any") && ($term !~ /^\+/)))
		{
		if ($term =~ / /)
			{
			$Important_Terms .= "\"" . $term . "\", ";
			}
		else
			{
			$Important_Terms .= $term . ", ";
			}
		push(@optional,&Format_Term($term));
		}
	else
		{
		if ($term =~ / /)
			{
			$Important_Terms .= "\"" . $term . "\", ";
			}
		else
			{
			$Important_Terms .= $term . ", ";
			}
		push(@optional,&Format_Term($term));
		}
	}



   $delimiter = '|';
   open(ALLFILE,"$Index_File") || &Fatal;
   foreach $LINE (<ALLFILE>)
	{
	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

        if ($Search_By eq "url") { 
            $string = $URL; 
            $string =~ s/http\:\/\///g;
        }
        elsif ($Search_By eq "mailto") { 
               $string = $Email; 
        }
        else { $string = "$Description $Keys"; }

	$string =~ s/\n/ /g;

	($Relevance,$Kill) = (0,0);
	foreach (@forbidden)
		{
		if (($string =~ /$_/i) && ($_ !~ /[A-Z]/))
			{
			$Kill++;
			last;
			}
		elsif ($string =~ /$_/)
			{
			$Kill++;
			last;
			}
		}
	next if ($Kill);
	foreach (@required)
		{
print "$_<BR>\n";
		if (($string =~ /$_/) && ($_ =~ /[A-Z]/))
			{
			$Relevance += (($string =~ s/$_/$_/og) + 20);
			}
		elsif (($string =~ /$_/i) && ($_ !~ /[A-Z]/))
			{
			$Relevance += (($string =~ s/$_/$_/oig) + 10);
			}
		else
			{
			$Kill++;
			last;
			}
		}
	next if ($Kill);
	foreach (@optional)
		{
		if (($string =~ /$_/) && ($_ =~ /[A-Z]/))
			{
			$Relevance += ($string =~ s/$_/$_/og);
			}
		elsif (($string =~ /$_/i) && ($_ !~ /[A-Z]/))
			{
			$Relevance += ($string =~ s/$_/$_/oig);
			}
		}

        if($ReqQualifier ne "") {
	   &Include if ($Qualifier eq $ReqQualifier && $Relevance && $URL ne "NONE" && $URL ne "None" && $URL ne "none");
	}
        else {
	   &Include if ($Relevance && $URL ne "NONE" && $URL ne "None" && $URL ne "none");
        }

	}
   close(ALLFILE);


   if ($Ignored_Terms =~ /(.*)\, /)
	{
	$Ignored_Terms = " " . $1;
	$Ignored_Terms =~ s/$WildCard/\*/g;
	$Ignored_Terms =~ s/ (\"?)\-/ $1/g;
	$summary .= "Ignored: <TT>$Ignored_Terms</TT>.<BR>\n";
	}
   else
	{
	$summary .= "<BR>\n";
	}
   if ($Important_Terms =~ /(.*)\, /)
	{
	$Important_Terms = " " . $1;
	$Important_Terms =~ s/$WildCard/\*/g;
	$Important_Terms =~ s/ (\"?)\+/ $1/g;
	$Important_Terms =~ s/ (\"?)\|/ $1/g;
        
        if ($Search_By eq "url") { $Heading .= "Searched for the $Search_By: <B>$Important_Terms</B>.<BR>\n"; }
        elsif ($Search_By eq "mailto") { $Heading .= "Searched for entries submitted by: <B>$Important_Terms</B>.<BR>\n"; }
	else { $Heading .= "Searched for: <B>$Important_Terms</B>.<BR>\n"; }
	}
   $Remaining = ($hitcount - $rank) - ($Hits_Per_Page - 1);
   if ($Remaining >= $Hits_Per_Page)
	{
	$Next = $Hits_Per_Page;
	$New_Rank = $rank + $Hits_Per_Page;
	}
   elsif ($Remaining > 0)
	{
	$Next = $Remaining % $Hits_Per_Page;
	$New_Rank = $rank + $Hits_Per_Page;
	}
   else
	{
	$New_Rank = $hitcount + 1;
	}


   $summary .= "Displaying documents " . $rank . "-" . ($New_Rank - 1);

   if ($yh_sort eq "TITLE") { $summary .= " of $hitcount, sorted alphabetically...<BR>\n"; }
   elsif ($yh_sort eq "BOTH") { $summary .= " of $hitcount, sorted alphabetically, in order of relevance...<BR>\n"; }
   else { $summary .= " of $hitcount, ranked in order of relevance...<BR>\n"; }
   if (($summary_file) && (-e $summary_file))
	{
	open(SUMMARY,">>$summary_file");
           $LOG = $Raw_Terms[0];
           $LOG =~ s/(\*+)//g;
           $LOG =~ s/ //g;
	   print SUMMARY "$LOG\n";
	close(SUMMARY);
	}



   print "<TABLE WIDTH=\"90%\"><TR BGCOLOR=\"$win_color\"><TD>\n";
   print "<FONT COLOR=\"$text_color\" FACE=\"$font_face\" SIZE=\"$font_size\">\n";
   print "<B>Search Results....</B></FONT></TD></TR></TABLE>\n";
   print $Heading;


   if ($hitcount > 0)
	{
	if ($Format eq "Standard")
		{
                print "<FONT FACE=\"$font_face\" COLOR=\"$text_color\" SIZE=\"$font_size\">\n";
		}
	else
		{
		print "<BR>\n<PRE>\n";
		}
	$i = 0;

        print "<H4>Hyperseek Category Matches...</H4>\n";
	foreach $key (reverse sort keys %CATS) 
	{
	   ($URL,$Title,$Description,$ID,$Cool,$Cat,$Sub) = split(/\|/,$CATS{$key});
           $LINK = "$Cat|$Sub";
           $LINK =~ s/ /+/g;
           print "<A HREF=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$LINK&Qualifier=$QualLink\">$Cat :: $Sub</A><BR>\n"; 
        }

        print "<H4>$summary</H4>\n";

	foreach $key (keys %HITS) {

	      @{$records[$count++]}{qw(URL Title Description ID Cool Cat Sub)}=split(/\|/,$HITS{$key},8);
        }

        if ($yh_sort eq "TITLE") { &Sort_by_Title; }
        elsif ($yh_sort eq "BOTH") { &Sort_by_Rank_and_Title; }
        else { &Sort_by_Rank; }

        for $j ( 0 .. $#links ) {

		$i++;
		next if ($i < $rank);
		next if ($i > ($rank + ($Hits_Per_Page - 1)));

                $URL = $links[$j]{'URL'};
                $Title = $links[$j]{'Title'};
                $Description = $links[$j]{'Description'};
                $ID = $links[$j]{'ID'};
                $Cool = $links[$j]{'Cool'};
                $Cat = $links[$j]{'Cat'};
                $Sub = $links[$j]{'Sub'};

		if ($Format eq "Standard")
			{
			if ($Size < 1500)
				{
				$Size = "$Size bytes";
				}
			else
				{
				$Size = int($Size/1000) . " K";
				}


                        #########################################
                        $COOL = "<A HREF=\"$CGI_DIR/hyperseek.cgi?search=COOL&Qualifier=$QualLink\"><IMG SRC=\"$button_dir/cool.gif\" BORDER=0></A>";
                        $NEW = "<A HREF=\"$CGI_DIR/hyperseek.cgi?search=NEW&Qualifier=$QualLink\"><IMG SRC=\"$button_dir/new.gif\" BORDER=0></A>";
                        #########################################

                        #########################################
                        ## Do we show a New Icon ??            ##
                        #########################################
                        $EXTRA="";
                        $now = time;
                        $then = $ID;
                        $diff = $now - $then;
                        $isnew = 1209600;
                        if( $diff < $isnew) { $EXTRA=$NEW; }
                        else { $EXTRA=""; }

                        #########################################                        
                        ## Do we show a Cool Icon ??           ##
                        #########################################                        
                        if($Cool >= $yh_cool) { $EXTRA .= $COOL; }

                        #########################################                        
                        ### Show the # of hits for this URL... ##
                        #########################################                        
                        if ($yh_show_hits ne "NO") {
                           $FILE = "$data_dir/hits/$ID.cnt";
                           open (COUNT, "$FILE");
                             @lines = <COUNT>;
                           close (COUNT);
                           @entries = split(/\|/,$lines[0]);
                           $num_hits = $entries[0];
                           $num_hits =~ s/\n//g; 
                           $COUNT = "[$num_hits] Hits&nbsp;&nbsp;&nbsp;";
                        }

                        $Cat =~ s/ /+/g;
                        $Sub =~ s/ /+/g;


                           if ($yh_show_desc ne "YES") { $Description = ""; }
                           if ($yh_show_url ne "YES") { $URL = ""; }

                           if ($yh_target ne "NONE") {
			      print "<P><A HREF=\"$CGI_DIR/go.cgi?ID=$ID\" TARGET=\"$yh_target\"><STRONG>$Title</STRONG></A>&nbsp;&nbsp;$COUNT $EXTRA<BR>";
			      print "$Description<BR><TT><I>$URL</I></TT>";
                              print "<BR><TT><A HREF=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$Cat|$Sub&Qualifier=$QualLink\">[More like this]</A></TT>\n";
                           }
                           else {
			      print "<P><A HREF=\"$CGI_DIR/go.cgi?ID=$ID\"><STRONG>$Title</STRONG></A>&nbsp;&nbsp;$COUNT $EXTRA<BR>";
			      print "$Description<BR><TT><I>$URL</I></TT>";
                              print "<BR><TT><A HREF=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$Cat|$Sub&Qualifier=$QualLink\">[More like this]</A></TT>\n";
                           }

			}


		else
			{
			&Compact_Print;
			}
		}
	if ($Format ne "Standard")
		{
		print "</PRE>\n";
		}

	print "Documents " . $rank . "-" . ($New_Rank - 1);
	print " of $hitcount displayed.<BR>\n";
	print "</BLOCKQUOTE>\n" if ($Format eq "Standard" && $style == 1);
	print "<CENTER>\n";

	if ($rank > $Hits_Per_Page) {
                $Back_Rank = $rank-$Hits_Per_Page;
		print "<A HREF=\"$CGI_DIR/hypersearch.cgi?Range=$Range\&Format=$Format\&Terms=$Encoded_Terms\&Rank=$Back_Rank&Qualifier=$QualLink\">";
		print "[Previous]</A>&nbsp;&nbsp;\n";
        }
	if ($Remaining > 0) {
		print "<A HREF=\"$CGI_DIR/hypersearch.cgi?Range=$Range\&Format=$Format\&Terms=$Encoded_Terms\&Rank=$New_Rank&Qualifier=$QualLink\">";
		print "[Next]</A>&nbsp;&nbsp;\n";

                $Total_Remaining_Pages = $hitcount/$Hits_Per_Page;
                for $T(0 .. $Total_Remaining_Pages) {
                    $Link_Text = $T + 1;
                    $Start_Num = ($T * $Hits_Per_Page) + 1;
		    print "<A HREF=\"$CGI_DIR/hypersearch.cgi?Range=$Range\&Format=$Format\&Terms=$Encoded_Terms\&Rank=$Start_Num&Qualifier=$QualLink\">";
		    print "[$Link_Text]</A>&nbsp;&nbsp;\n";
                }
        }

	}
	else
	{
        print "<FONT FACE=\"$font_face\" COLOR=\"$text_color\" SIZE=\"$font_size\">\n";
	print $No_Documents_Found;
	}

	print "</CENTER>\n";
	print "</FONT>\n";

   $Saved_Terms =~ s/\"/\&#34;/g;


}




sub Include {

   $Relevance = ($Relevance * $Crank) if ($Crank > 1);
   $Relevance = 100000 if ($Relevance > 100000);
   $Relevance = sprintf("%.5f",($Relevance/100000));

   $CATS{"$Category$SubCategory"} = $URL . $delimiter . $Title . $delimiter . $Description . $delimiter. $ID . $delimiter . $Crank . $delimiter . $Category . $delimiter . $SubCategory;

   $HITS{"$Relevance$URL"} = $URL . $delimiter . $Title . $delimiter . $Description . $delimiter. $ID . $delimiter . $Crank . $delimiter . $Category . $delimiter . $SubCategory;
   $hitcount++;
}

sub Compact_Print {

   if (length($Title) < 25)
	{
	while (length($Title) < 25)
		{
		$Title .= " ";
		}
	}
   else
	{
	@Title_Characters = split(//,$Title);
	$Title = "";
	for ($x=0; $x<25; $x++)
		{
		$Title .= $Title_Characters[$x];
		}
	}
   if (length($Description) < 36)
	{
	while (length($Description) < 36)
		{
		$Description .= " ";
		}
	}
   else
	{
	@Descript_Characters = split(//,$Description);
	$Description = "";
	for ($x=0; $x<36; $x++)
		{
		$Description .= $Descript_Characters[$x];
		}
	}
   if (length($Last_Modified) == 8)
	{
	$Last_Modified = "0" . $Last_Modified;
	}

   if ($yh_target ne "NONE") {
      print "<FONT FACE=\"$font_face\" COLOR=\"$text_color\" SIZE=\"$font_size\">\n";
      print "<A HREF=\"$URL\" TARGET=\"$yh_target\">$Title</A> [$Last_Modified] $Description\n";
   }
   else {
      print "<FONT FACE=\"$font_face\" COLOR=\"$text_color\" SIZE=\"$font_size\">\n";
      print "<A HREF=\"$URL\">$Title</A> [$Last_Modified] $Description\n";
   }
}



sub Format_Term {

   $PERIOD=".";

   $_ = shift;

   if (! $Search_By) { 
     $_ = " " . $_ . " ";
   }

   $_ =~ s/\W/ /g;
   $_ =~ s/\s+/ /g;
   $_ =~ s/$WildCard/\(\[\^\\s\+\]\{0,4\}\)/g;


   if ($Search_By) { 
       $_ =~ s/ /$PERIOD/g;
   }

   return $_;
}



sub Fatal {

   print "Content-type: text/plain\n\n";
   print "Fatal Error: Could not read from the index file.\n";
   print "Check location at $Index_File.\n\n";

   exit;
}




sub Menu{}

sub Categories{}

