#!/usr/local/bin/perl
##############################################################################
# Hyperseek Search Engine                                                    #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Hyperseek Search Engine, including all files in this distribution      #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################



##################################################################
###  ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------###
##################################################################


### Pull In External Files ###

    require ("iweb.pm");
    require ("hyperseek.pm");

$PROGRAM="Hyperseek Search Engine";
$VERSION="6.01";

### Define Images and Data Files ###

    $Index_File = "$data_dir/hyperseek.dat";
    $summary_file = "$data_dir/summaries.html";
    $sub_category_data = "$data_dir/subcategories.dat";
    $category_main = "$data_dir/categories.dat";
    $BigFolder = "$button_dir/big_folder.gif";
    $RelatedFolder = "$button_dir/related.gif";

      if ($FolderSize eq "big") {
         $SmallFolder = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<IMG SRC=\"$button_dir/message.gif\" BORDER=0>";
      }
      elsif ($FolderSize eq "none") {
         $SmallFolder = "";
         $BigFolder = "$button_dir/none.gif";
         $RelatedFolder = "$button_dir/none.gif";
      }
      else {
         $SmallFolder = "<IMG SRC=\"$button_dir/folder.gif\" BORDER=0>&nbsp;";
      }




### Words to ignore ###

    $Ignore .= " what how who which when where do you find site get and ";
    $Ignore .= " or if not a the for an it of from by the one two to he ";
    $Ignore .= " most all about i me search is are be been with why ";





# __________________________________________________________________
#
#       Get it started......
# __________________________________________________________________


    &parse_form;
    $password = $input{'password'};

    $ReqQualifier = $input{'Qualifier'};
    if ($ReqQualifier eq "NONE") { $ReqQualifier = "" };
        $QualLink = $ReqQualifier;
        $QualLink =~ s/ /+/g;

    $rank = $input{'Rank'};
      if($rank eq "") { $rank = 1; }

    $Range = $input{'Range'};
      if(!($Range)) {$Range = "Any"};
    $Format = "input{'Format'}";
      if(!($Format)) {$Format = "Standard"};


    $SEARCH_TYPE = $input{'search'};

    if ($SEARCH_TYPE eq "CAT") {

        @Terms = split(/\|/,$input{'Category'});

        $Saved_Terms = $input{'Category'};

        $ReqCategory = $Terms[0];
        $ReqSubCategory = $Terms[1];
        @ReqSubs = split(/\:/,$ReqSubCategory);
        $levels = $#ReqSubs;
    
        $Saved_Terms = "$ReqCategory $ReqSubCategory";
        $Encoded_Terms = "$ReqCategory|$ReqSubCategory";
        $Encoded_Terms =~ s/ /+/g;
    
        $grp = "$ReqCategory $ReqSubCategory";
        $grp =~ s/ /_/g;
        $grp =~ s/\:/_/g;
    
        $baseCAT = "$ReqCategory ";
        $baseCAT =~ s/ /_/g;
        $baseCAT =~ s/\:/_/g;

    }

    elsif ($SEARCH_TYPE eq "NEW") {

        $DATE = $input{'Date'};
        $DATE2 = $DATE + 1;
        $grp = "new";

    }


    elsif ($SEARCH_TYPE eq "COOL") {

        $grp = "cool";

    }


    else { 
        print "Location: $Search_Page\n\n"; 
        exit 0;
    }

    &Page_Header($grp);
    exit 0;


sub Body {


    print "<FONT FACE=\"$font_face\" SIZE=\"$font_size\">\n";

    $delimiter = "|";
    
    open(ALLFILE,"$Index_File") || &Fatal;

    foreach $LINE (<ALLFILE>) {

	($ID,$Category,$SubCategory,$Crank,$Qualifier,$Email,$Title,$URL,$Description,$string,$filler1,$filler2,$filler3,$filler4) = split(/\|/,$LINE);

	($Relevance,$Kill) = (0,0);
	next if ($Kill);


        if ($SEARCH_TYPE eq "CAT") {

            $string = $Category . " " . $SubCategory;
	    $string =~ s/\n/ /g;

            if($string eq $Saved_Terms) {
                $Relevance += (($string =~ s/$_/$_/og) + 20);
                $category = $Category;
                $sub_category = $SubCategory;

                if($ReqQualifier ne "") {
	           &Include if ($Relevance && $Qualifier eq $ReqQualifier);
	        }
                else {
	           &Include if ($Relevance);
                }
            }
            else {
                $Kill++;
            }



        }

        elsif ($SEARCH_TYPE eq "COOL") {
            if( $Crank >= $yh_cool && $URL ne "NONE" && $URL ne "None" && $URL ne "none") {

                if($ReqQualifier ne "") {
                   $Relevance = 1;
	           &Include if ($Qualifier eq $ReqQualifier);
	        }
                else {
                   $Relevance = 1;
	           &Include;
                }
            }
        } 

        elsif ($SEARCH_TYPE eq "NEW") {
            $now = time;
            $then = $ID;
            $diff = ($now - $then) / 86400;
   
            if( $diff >= $DATE && $diff < $DATE2 && $URL ne "NONE" && $URL ne "None" && $URL ne "none" ) { 
                if($ReqQualifier ne "") {
                   $Relevance = 1;
	           &Include if ($Qualifier eq $ReqQualifier);
	        }
                else {
                   $Relevance = 1;
	           &Include;
                }

            }

            else {
               $Kill++;
            }
        }
  


    }

    close(ALLFILE);



    $Remaining = ($hitcount - $rank) - ($Hits_Per_Page - 1);

    if ($Remaining > $Hits_Per_Page)
	{
	$Next = $Hits_Per_Page;
	$New_Rank = $rank + $Hits_Per_Page;
	}
    elsif ($Remaining > 0)
	{
	$Next = $Remaining % $Hits_Per_Page;
	$New_Rank = $rank + $Hits_Per_Page;
	}
    else
	{
	$New_Rank = $hitcount + 1;
	}

    $summary .= "<B>Listings ...</B> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Displaying documents " . $rank . "-" . ($New_Rank - 1);
    $summary .= " of $hitcount.<BR>\n";

    print "<BR><I>$summary</I><BR>\n"; 

    if ($yh_qualify eq "Yes") {
            print "<FORM ACTION=\"$CGI_DIR/hyperseek.cgi\">\n";
            $L1 = $ReqCategory;
            $L1 =~ s/\+/ /g;
            $L2 = $ReqSubCategory;
            $L2 =~ s/\+/ /g;
            print "<INPUT TYPE=\"hidden\" NAME=\"Category\" VALUE=\"$L1|$L2\">\n";
            print "<INPUT TYPE=\"hidden\" NAME=\"search\" VALUE=\"CAT\">\n";
            print "<INPUT TYPE=\"hidden\" NAME=\"rank\" VALUE=\"$rank\">\n";
            print "Refine Category Contents: \n";
            $search_code = "";
            &Qualifiers;
            print $search_code;
            print "<INPUT TYPE=\"submit\" VALUE=\"Reload\">\n";
            print "</FORM>\n";
    }


    if ($hitcount > 0)
	{
	print "<BR><DL>\n";

	$i = 0;
	foreach $key (keys %HITS) {

	      @{$records[$count++]}{qw(URL Title Description ID Cool Cat Sub)}=split(/\|/,$HITS{$key},8);
        }

        if ($yh_sort eq "TITLE") { &Sort_by_Title; }
        elsif ($yh_sort eq "BOTH") { &Sort_by_Rank_and_Title; }
        else { &Sort_by_Rank; }

        for $j ( 0 .. $#links ) {

		$i++;
		next if ($i < $rank);
		next if ($i > ($rank + ($Hits_Per_Page - 1)));

                $URL = $links[$j]{'URL'};
                $Title = $links[$j]{'Title'};
                $Description = $links[$j]{'Description'};
                $ID = $links[$j]{'ID'};
                $Cool = $links[$j]{'Cool'};
                $Cat = $links[$j]{'Cat'};
                  $Cat =~ s/ /+/g;
                $Sub = $links[$j]{'Sub'};
                  $Sub =~ s/ /+/g;
        
                        #########################################                        
                        $COOL = "<A HREF=\"$CGI_DIR/hyperseek.cgi?search=COOL&Qualifier=$QualLink\"><IMG SRC=\"$button_dir/cool.gif\" BORDER=0></A>";
                        $NEW = "<A HREF=\"$CGI_DIR/hyperseek.cgi?search=NEW&Qualifier=$QualLink\"><IMG SRC=\"$button_dir/new.gif\" BORDER=0></A>";
                        #########################################                        

                        #########################################                        
                        ## Do we show a New Icon ??            ##
                        #########################################                        
                        $EXTRA="";
                        $now = time;
                        $then = $ID;
                        $diff = $now - $then;
                        $isnew = 1209600;
                        if( $diff < $isnew) { $EXTRA=$NEW; }

                        #########################################                        
                        ## Do we show a Cool Icon ??           ##
                        #########################################                        
                        if($Cool >= $yh_cool) { $EXTRA .= $COOL; }

                        #########################################                        
                        ### Show the # of hits for this URL... ##
                        #########################################                        
                        if ($yh_show_hits ne "NO") {
                           $FILE = "$data_dir/hits/$ID.cnt";
                           open (COUNT, "$FILE");
                             @lines = <COUNT>;
                           close (COUNT);
                           @entries = split(/\|/,$lines[0]);
                           $num_hits = $entries[0];
                           $num_hits =~ s/\n//g; 
                           $COUNT = "[$num_hits] Hits&nbsp;&nbsp;&nbsp;";
                        }

                        if ($URL =~ "NONE" || $URL =~ "None" || $URL eq "none") {
                           print "$Description<BR>\n";
                        }
                        else {

                           if ($yh_show_desc ne "YES") { $Description = ""; }
                           if ($yh_show_url ne "YES") { $URL = ""; }

                           if ($yh_target ne "NONE") {
			      print "<P><A HREF=\"$CGI_DIR/go.cgi?ID=$ID\" TARGET=\"$yh_target\"><STRONG>$Title</STRONG></A>&nbsp;&nbsp;$COUNT $EXTRA<BR>";
			      print "$Description<BR><TT><I>$URL</I></TT>";
                           }
                           else {
			      print "<P><A HREF=\"$CGI_DIR/go.cgi?ID=$ID\"><STRONG>$Title</STRONG></A>&nbsp;&nbsp;$COUNT $EXTRA<BR>";
			      print "$Description<BR><TT><I>$URL</I></TT>";
                           }
                           if ($SEARCH_TYPE ne "CAT") {
                               print "<BR><TT><A HREF=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$Cat|$Sub&Qualifier=$QualLink\">[More like this]</A></TT>\n";
                           }
                        }

			}

	print "</DL>\n";

	print "Documents " . $rank . "-" . ($New_Rank - 1);
	print " of $hitcount displayed.<BR>\n";
	print "<CENTER>\n";
	if ($rank > $Hits_Per_Page) {
                $Back_Rank = $rank-$Hits_Per_Page;
		print "<A HREF=\"$CGI_DIR/hyperseek.cgi?search=$SEARCH_TYPE&Category=$Encoded_Terms&Rank=$Back_Rank&Qualifier=$QualLink\">";
		print "[Previous]</A>&nbsp;&nbsp;\n";
        }
	if ($Remaining > 0) {
		print "<A HREF=\"$CGI_DIR/hyperseek.cgi?search=$SEARCH_TYPE&Category=$Encoded_Terms&Rank=$New_Rank&Qualifier=$QualLink\">";
		print "[Next]</A>&nbsp;&nbsp;\n";

                $Total_Remaining_Pages = $hitcount/$Hits_Per_Page;
                for $T(0 .. $Total_Remaining_Pages) {
                    $Link_Text = $T + 1;
                    $Start_Num = ($T * $Hits_Per_Page) + 1;
		    print "<A HREF=\"$CGI_DIR/hyperseek.cgi?search=$SEARCH_TYPE&Category=$Encoded_Terms&Rank=$Start_Num&Qualifier=$QualLink\">";
		    print "[$Link_Text]</A>&nbsp;&nbsp;\n";
                }
        }
	print "</CENTER>\n";

	}
   else
	{
	print $No_Documents_Found;
	}

   $Saved_Terms =~ s/\"/\&#34;/g;


   ##### End of Document .....

   print "</FONT>\n";


}



sub Include {

   $Relevance = ($Relevance * $Crank) if ($Crank > 1);
   $Relevance = 100000 if ($Relevance > 100000);
   $Relevance = sprintf("%.5f",($Relevance/100000));
   $HITS{"$Relevance$URL"} = $URL . $delimiter . $Title . $delimiter . $Description . $delimiter. $ID . $delimiter . $Crank . $delimiter . $Category . $delimiter . $SubCategory;
   $hitcount++;
}



sub Fatal {

   print "Content-type: text/plain\n\n";
   print "Fatal Error: Could not read from the index file.\n";
   print "Check location at $Index_File.\n\n";
   exit;
}


sub Format_Term {

   $PERIOD=".";

   $_ = shift;

   if (! $Search_By) { 
     $_ = " " . $_ . " ";
   }

   $_ =~ s/\W/ /g;
   $_ =~ s/\s+/ /g;
   $_ =~ s/$WildCard/\(\[\^\\s\+\]\{0,4\}\)/g;


   if ($Search_By) { 
       $_ =~ s/ /$PERIOD/g;
   }

   return $_;
}


###################

sub Menu {

  &ReadCategories;

  $REFERER="$ENV{'HTTP_REFERER'}";


  if ($SEARCH_TYPE eq "CAT") {

        if($win_color) {
           print "<TABLE BORDER=0 WIDTH=\"90%\" CELLSPACING=0 CELLPADDING=0 BGCOLOR=\"$win_color\">\n";
        }
        else {
           print "<TABLE BORDER=0 WIDTH=\"90%\" CELLSPACING=0 CELLPADDING=0>\n";
        }

        print "<TR><TD VALIGN=\"top\">\n";
        print "<FONT FACE=\"$font_face\" SIZE=\"$font_size\">\n";
        $Top_Link = $ReqCategory;
        $Top_Link =~ s/ /+/g;
        $Top_Text = $ReqCategory;
        print "<A HREF=\"$CGI_DIR/directory.cgi\">Home</A> :: <A HREF=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$Top_Link&Qualifier=$QualLink\">$Top_Text</A><B> / </B>";
     
        for $x(0 .. $levels) {
     
            $NewLink = "$ReqSubs[$x]";
            $Text = "$ReqSubs[$x]";
            $Text =~ s/\:/ \/ /g;
            $OldLink = $Link;
          
            if ($x == 0) { 
               $Link = $NewLink;
            }
            else { 
               $Link = "$OldLink:$NewLink";
            }
            
            $Link =~ s/ /+/g;
            $LinkCat = $ReqCategory;
            $LinkCat =~ s/ /+/g;


     
            if ($x == 0) {
               print "<a href=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$LinkCat|$Link&Qualifier=$QualLink\">$Text</a>\n";
            }
            else {
               print "<B> / </B><a href=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$LinkCat|$Link&Qualifier=$QualLink\">$Text</a>\n";
            }
       
        }   
        print "</FONT></TD></TR></TABLE>\n";

   }

   elsif ($SEARCH_TYPE eq "COOL") {
        if($win_color) {
           print "<TABLE BORDER=0 WIDTH=\"100%\" CELLSPACING=0 CELLPADDING=0 BGCOLOR=\"$win_color\">\n";
        }
        else {
           print "<TABLE BORDER=0 WIDTH=\"100%\" CELLSPACING=0 CELLPADDING=0>\n";
        }
        print "<TR><TD VALIGN=\"top\">\n";
        print "<FONT FACE=\"$font_face\" SIZE=\"$font_size\">\n";
        print "<H3><a href=\"$REFERER\">Back</A> / Whats Cool!</H3>\n";
        print "</TD></TR></TABLE>\n";
   }

   elsif ($SEARCH_TYPE eq "NEW") {

        $TIME = time - ($DATE * 86400);

        ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($TIME);
        $DAY = (Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday)[(localtime($TIME))[6]];
        $MONTH = (January,Februrary,March,April,May,June,July,August,September,October,November,December)[(localtime($TIME))[4]];
        $DateString = "$DAY $MONTH $mday, 19$year";

        if($win_color) {
           print "<TABLE BORDER=0 WIDTH=\"100%\" CELLSPACING=0 CELLPADDING=0 BGCOLOR=\"$win_color\">\n";
        }
        else {
           print "<TABLE BORDER=0 WIDTH=\"100%\" CELLSPACING=0 CELLPADDING=0>\n";
        }
        print "<TR BGCOLOR=\"$win_color\"><TD>\n";

        print "<TR BGCOLOR=\"$win_color\"><TD COLSPAN=2>\n";
        print "<FONT FACE=\"$font_face\" SIZE=\"$font_size\">\n";
        print "<H3><a href=\"$REFERER\">Back</A> / <a href=\"$CGI_DIR/new.cgi\">What's New</a>&nbsp;&nbsp;&nbsp;$DateString</H3>\n";
        print "</TD></TR></TABLE>\n";


   }


}



sub Categories {

  &ReadCategories;

        print "<TABLE BORDER=0><TR>\n";
        for $i( 0 .. $#subcategories ) {

          @entries = split(/\|/,$subcategories[$i]);

          $Category = $entries[1];
          $Count = $entries[3];
          $Count =~ s/\n//g;
          if($yh_show_count ne "NO") { $CNT = "($Count)"; }

          $Sub = $entries[2];
             @subs = split(/\:/,$Sub);
             $num_subs = $#subs;
             $num_levels_to_show = $levels + 1;


          if ( $ReqCategory eq $Category )   { 
    
             if ($num_subs == 0) {
                $LookFor = "$Sub";
             }
             else {
                for $x(0 .. $levels) {
                   if($x == 0) { $LookFor = $ReqSubs[$x]; }
                   else { $LookFor .= ":$ReqSubs[$x]"; }
  
                }
             }
             $Category =~ s/ /+/g;
             if ($Sub =~ $LookFor && $num_subs eq $num_levels_to_show) {

                if ($NumSubs >= $yh_menu_columns) {
                   print "</TR><TR>\n";
                   $NumSubs=0;
                }

                $Link = $Sub;
                $Sub =~ s/$ReqSubCategory://g;
                $Link =~ s/ /+/g;
                $NumSubs++;
                print "<TD VALIGN=\"top\" ALIGN=\"left\">\n"; 
                print "<FONT FACE=\"$font_face\" SIZE=\"$font_size\">\n";
                print "&nbsp;&nbsp;$SmallFolder<a href=\"$CGI_DIR/hyperseek.cgi?search=CAT&Category=$Category|$Link&Qualifier=$QualLink\">$Sub</a> $CNT</FONT></TD>\n";
             }

          }
    

        }

        # $ReqCategory =~ s/ /+/g;
        # $ReqSubCategory =~ s/ /+/g;

        print "</TR></TABLE>\n";


}






